package geniusweb.party.inform;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;

import geniusweb.party.Party;

import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;

/**
 * base class of all information sent to the {@link Party}
 */
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.WRAPPER_OBJECT)
@JsonSubTypes({ @JsonSubTypes.Type(value = ActionDone.class),
		@JsonSubTypes.Type(value = Inform.class),
		@JsonSubTypes.Type(value = Settings.class),
		@JsonSubTypes.Type(value = Finished.class),
		@JsonSubTypes.Type(value = YourTurn.class) })
@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
public interface Inform {

}
